;



LIST p=12f675		

include <p12f675.inc>
__config 0F9C	;4



#define 	TX		GPIO,0
#define  	OUT		GPIO,2
#define  	REF		GPIO,4





STATUS_TEMP		EQU 	21h 

W_TEMP			EQU 	22h 



		
						
TM1    		EQU 	30h           	;
TM2    		EQU 	31h          	;
TM3    		EQU 	32h          	;
TM4    		EQU 	33h          	;
TM5    		EQU 	34h		;
TM6    		EQU 	35h		;




COD		EQU	39h
count           EQU	3Ah

REP    		EQU 	42h		; -  




ADR_1		EQU	50h		;    
ADR_2		EQU	51h		;      /  
ADR_3		EQU	52h		;     /  







;*********************************************************************************************************************************

	ORG	 	0x00 
	
	GOTO 	INIT
	
	
	ORG	 	0x04 

	;MOVWF 	W_TEMP   			;     
      	;SWAPF 	STATUS,W
      	;MOVWF 	STATUS_TEMP

     	;SWAPF 	STATUS_TEMP,W
     	;MOVWF 	STATUS
     	;SWAPF 	W_TEMP,F
     	;SWAPF 	W_TEMP,W

	RETFIE
	

	
	
INIT

	BSF     	STATUS,RP0
	CALL		3FFh
	MOVWF	OSCCAL

	BCF     	STATUS,RP0

	MOVLW 	 0x07			;   GPIO1 ,  0x07 =  I/O
	MOVWF	CMCON

	
	BSF     	STATUS,RP0
	CLRF		ANSEL
	MOVLW 	b'00000010' 		; GPIO1 - ,  
	MOVWF	TRISIO
        clrf            WPU                     ;  
        clrf	        VRCON                   ;    
; 	MOVLW 	b'10001111' 		;  Vref 
; 	MOVWF	VRCON

	
	MOVLW 	b'00001111'		; WDT 1/128 ( 2    SLEEP)
	MOVWF	OPTION_REG


	BCF     	STATUS,RP0
        MOVLW 	b'00010000'
        MOVWF   GPIO
        movlw           0x02
        movwf           count

;*********************************************************************************************************************************
;  
;*********************************************************************************************************************************

	
	
 

START
        CLRWDT
        MOVLW 	 0x07
	MOVWF	CMCON                           ;  
       	BSF     	STATUS,RP0
        clrf	        VRCON                   ;    
	BCF     	STATUS,RP0

	SLEEP                                   ;   
        nop

	MOVLW 	 0x0C                           ;  
	MOVWF	CMCON
	BSF     	STATUS,RP0
	MOVLW 	        b'10001111' 		;  Vref 
        MOVWF	        VRCON                   ;  Vref =       6
	BCF     	STATUS,RP0
	CALL		D500
	CALL		D500

	BTFSS	CMCON,6		;       1.9
	
	GOTO		ch_pov

; 	CLRF		ADR_1
; 	CLRF		ADR_2
; 	CLRF		ADR_3

	CALL		EEPROM_LOAD		;    

	CALL		TX_ADRES
	CALL		TX_ADRES
	CALL		TX_ADRES
	CALL		TX_ADRES
	CALL		TX_ADRES
	CALL		TX_ADRES

	BSF		TX
	CALL		Delay_1S
	BCF		TX

	GOTO		START	

ch_pov  decfsz          count,f
        GOTO		START
        movlw           0x16                    ;    WDT      
        movwf           count
        movlw           0x06
	CALL		LOAD                    ;     
	ANDLW           0x0F                    ;            
        IORLW           0xA0                    ;       8
	BSF     	STATUS,RP0
        MOVWF	        VRCON                   ;  Vref =       6
	BCF     	STATUS,RP0
        BCF		REF
        CALL		Delay_100
        BTFSC	        CMCON,6
        GOTO            ret_st
        BSF		REF
	CALL		EEPROM_LOAD_P		;     
        
	CALL		TX_ADRES
	CALL		TX_ADRES
	CALL		TX_ADRES
	CALL		TX_ADRES
        CALL		TX_ADRES
	CALL		TX_ADRES
	BSF		TX
        CALL		Delay_100
        CALL		Delay_100
        CALL		Delay_100
        CALL		Delay_100
        CALL		Delay_100
        BCF		TX
ret_st	
        BSF		REF

	GOTO		START

;*********************************************************************************
;  
;*********************************************************************************




TX_ADRES
	BSF		OUT
	CALL		D500
	BCF		OUT
	CALL		Delay_100

	MOVF		ADR_1,0
	MOVWF		COD
	MOVLW		0x08		
	MOVWF		REP
	CALL		ADR_GEN


	
	MOVF		ADR_2,0
	MOVWF		COD
	MOVLW		0x08		
	MOVWF		REP
	CALL		ADR_GEN

	MOVF		ADR_3,0
	MOVWF		COD
	MOVLW		0x08		
	MOVWF		REP
	CALL		ADR_GEN


	RETURN

	
	




	


ADR_GEN	
		                          ;
	BTFSS		COD,7             ;     
	GOTO		TMS_0		
	GOTO		TMS_1		

TMS_1	
	BSF		OUT			
	CALL		D500
	CALL		D500
	CALL		D500
	BCF		OUT
	CALL		D500
	GOTO		CIKL

TMS_0	
	BSF		OUT			
	CALL		D500
	BCF		OUT
	CALL		D500
	CALL		D500
	CALL		D500
	
CIKL	
	RLF		COD,1              ;     
	DECFSZ		REP,1
	GOTO		ADR_GEN
	CLRF		COD
	RETURN







;====================== 500 =================

D500	
	CLRF		TM1
	movlw	0x96
	movwf	TM1
Delay_0500
	decfsz	TM1, f
	goto		Delay_0500
	nop
	RETURN




;===============================================================================	
;	A       EEPROM
;===============================================================================

EEPROM_LOAD	
			
	MOVLW		0x00			;  
	CALL		LOAD
	MOVWF		ADR_1
	
	
	MOVLW		0x01			;     /  
	CALL		LOAD 
	MOVWF		ADR_2
	
	MOVLW		0x02			;     /  
	CALL		LOAD 
	MOVWF		ADR_3	
	
	RETURN                  
	
EEPROM_LOAD_P

	MOVLW		0x03		
	CALL		LOAD 
	MOVWF		ADR_1
	
	
	MOVLW		0x04			
	CALL		LOAD 
	MOVWF		ADR_2
	
	MOVLW		0x05			
	CALL		LOAD 
	MOVWF		ADR_3	
	

	RETURN

;==========================================

LOAD 

	BSF     	STATUS,RP0       	;  1
	MOVWF   	EEADR		; 			
	BSF		EECON1,RD
	MOVF		EEDATA,0
	BCF     	STATUS,RP0      	;  0


	RETURN	


	
;======================================================================
;	  1 
;======================================================================

Delay_1S
	movlw	0x08
	movwf 	TM4
	movlw	0x2F
	movwf	TM5
	movlw	0x03
	movwf	TM6	
Delay_0
	CLRWDT					;    (WDT)!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	decfsz	TM4, f
	goto		$+2
	decfsz	TM5, f
	goto		$+2
	decfsz	TM6, f
	goto		Delay_0
	goto		$+1
	nop
	RETURN


;======================================================================
;	  100 
;======================================================================

Delay_100				
	MOVLW	0x1F
	MOVWF	TM1
	MOVLW	0x0D
	MOVWF	TM2
Delay_0100
	DECFSZ	TM1, f
	GOTO		$+2
	DECFSZ	TM2, f
	GOTO		Delay_0100
	GOTO		$+1
	CLRWDT
	RETURN	
	
	
	
	
;======================================================================
; initialize eeprom locations
		ORG	0x2100                                    ;  
		DE	0x12, 0x04, 0xA0,    0x12, 0x04, 0xA1,     0x05  ; ,  ,    
;========================

		END                 ;   directive 'end of program'


	
